﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.XamarinForms.Primitives;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace SampleApp
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class PopupView : ContentView
	{
        private RadPopup popup;
        private View popupContent;

		public PopupView ()
		{
			InitializeComponent ();

            MessagingCenter.Subscribe<PopupViewModel>(this, "ShowPopup", this.CreatePopup);        
        }
        
        private void CreatePopup(PopupViewModel vm)
        {
            Page page = null;
            Element element = this;
            while (page == null && element != null)
            {
                element = element.Parent;
                page = element as Page;
            }

            if (page != null)
            {
                if (this.popupContent == null)
                {
                    this.popupContent = (View)((ControlTemplate)this.Resources["PopupTemplate"]).CreateContent();                    
                }

                if (this.popup == null)
                {
                    this.popup = new RadPopup();
                    this.popup.Content = this.popupContent;                

                    this.popup.IsModal = true;
                    this.popup.OutsideBackgroundColor = Color.FromHex("6F000000");
                    this.popup.Placement = PlacementMode.Center;
                    this.popup.AnimationType = PopupAnimationType.Zoom;                  
       
                }                
                this.popup.IsOpen = true;
            }
        }
    }
}